#######################################
## This code is seperate from DBS.   ##
## If you have any question relating ##
## to the program design please do   ##
## NOT contact DBS.                  ##
##                                   ##
## The code is NOT runable.          ##
#######################################
## (c) 1997 by Ansgar Schmidt        ##
## ansi@tzi.org                      ##
#######################################

void calcAllSolutions(ALLOBJECT_TYP		*pAllObjectsWB,
					  ALLOBJECT_TYP		*pAllObjectsP,
					  ALLSOLUTION_TYP	*pAllSolutions,
					  int				nActualPosition,
					  int				*pPosibleSolutions){

    int              i,j,k,l;

    ALLOBJECT_TYP   *pAllObjectsPNew=NULL;

    int             *pPosibleSolutionsNew =NULL;

    if(nActualPosition == (pAllSolutions[0].length)){

        pAllSolutions[0].numberOfSolutions++;

        pAllSolutions[0].pSolutions[pAllSolutions[0].numberOfSolutions-1].pPObjects= 

            (int *)malloc(pAllSolutions[0].length*(sizeof(int)));

        for(j=0;j<pAllSolutions[0].length;j++){ 

            pAllSolutions[0].pSolutions[pAllSolutions[0].numberOfSolutions-1].pPObjects[j]=

                pPosibleSolutions[j]; 

        }

    } else {

        switch(pAllSolutions[0].pWBObjectTyps[nActualPosition]){

        case O_QUADRAT:

            for(k=0;k<pAllObjectsP[0].nQuadrats;k++){

                if(pAllObjectsP[0].pQuadrats[k].used == 0){

                    pAllObjectsPNew=(ALLOBJECT_TYP *)malloc(sizeof(ALLOBJECT_TYP));

                    copyAllObjects(pAllObjectsP,pAllObjectsPNew);

                    pAllObjectsPNew[0].pQuadrats[k].used = 1;

                    pPosibleSolutionsNew = (int *)

                                              malloc(pAllSolutions[0].length*sizeof(int));

                    for(l=0;l<pAllSolutions[0].length;l++){

                        pPosibleSolutionsNew[l]=pPosibleSolutions[l];

                    }

                    pPosibleSolutionsNew[nActualPosition]=pAllObjectsP[0].pQuadrats[k].number;

                    calcAllSolutions(pAllObjectsWB,pAllObjectsPNew,pAllSolutions,

                                     nActualPosition+1,pPosibleSolutionsNew);

                }}

            break;

        case O_RECTANGLE:

            <Equivalent to computation of O_QUADRAT>

            break;

        case O_CIRCLE:

            <Equivalent to computation of O_QUADRAT >

            break;

        case O_OVAL:

            <Equivalent to computation of O_QUADRAT >

            break;

        case O_TRIANGLE:

            <Equivalent to computation of O_QUADRAT >

            break;

        case O_NOT_INTERESTING:

            <Equivalent to computation of O_QUADRAT >

            break;

        }}}

h

